aboutsummaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
authorchriseth <chris@ethereum.org>2018-02-27 03:41:18 +0800
committerchriseth <chris@ethereum.org>2018-02-27 19:08:27 +0800
commit6a83beaab52e0601c1e7654d27a8e72f53b77182 (patch)
tree6cbdd2015e506670e9b8bd1af2dc1a35107c5a4e /scripts
parentb9dccf9f20d8f4348966e3c6cacd11fbda47c162 (diff)
downloaddexon-solidity-6a83beaab52e0601c1e7654d27a8e72f53b77182.tar
dexon-solidity-6a83beaab52e0601c1e7654d27a8e72f53b77182.tar.gz
dexon-solidity-6a83beaab52e0601c1e7654d27a8e72f53b77182.tar.bz2
dexon-solidity-6a83beaab52e0601c1e7654d27a8e72f53b77182.tar.lz
dexon-solidity-6a83beaab52e0601c1e7654d27a8e72f53b77182.tar.xz
dexon-solidity-6a83beaab52e0601c1e7654d27a8e72f53b77182.tar.zst
dexon-solidity-6a83beaab52e0601c1e7654d27a8e72f53b77182.zip
Run tests in parallel on circle.
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/tests.sh100
1 files changed, 56 insertions, 44 deletions
diff --git a/scripts/tests.sh b/scripts/tests.sh
index d414643b..3c80adc5 100755
--- a/scripts/tests.sh
+++ b/scripts/tests.sh
@@ -45,54 +45,66 @@ else
fi
echo "Running commandline tests..."
-"$REPO_ROOT/test/cmdlineTests.sh"
+"$REPO_ROOT/test/cmdlineTests.sh" &
+CMDLINE_PID=$!
+# Only run in parallel if this is run on CI infrastructure
+if [ -z "$CI" ]
+then
+ wait $CMDLINE_PID
+fi
-# This conditional is only needed because we don't have a working Homebrew
-# install for `eth` at the time of writing, so we unzip the ZIP file locally
-# instead. This will go away soon.
-if [[ "$OSTYPE" == "darwin"* ]]; then
- ETH_PATH="$REPO_ROOT/eth"
-elif [ -z $CI ]; then
- ETH_PATH="eth"
-else
- mkdir -p /tmp/test
- ETH_BINARY=eth_byzantium_artful
- ETH_HASH="e527dd3e3dc17b983529dd7dcfb74a0d3a5aed4e"
- if grep -i trusty /etc/lsb-release >/dev/null 2>&1
- then
- ETH_BINARY=eth_byzantium2
- ETH_HASH="4dc3f208475f622be7c8e53bee720e14cd254c6f"
+function download_eth()
+{
+ if [[ "$OSTYPE" == "darwin"* ]]; then
+ ETH_PATH="$REPO_ROOT/eth"
+ elif [ -z $CI ]; then
+ ETH_PATH="eth"
+ else
+ mkdir -p /tmp/test
+ ETH_BINARY=eth_byzantium_artful
+ ETH_HASH="e527dd3e3dc17b983529dd7dcfb74a0d3a5aed4e"
+ if grep -i trusty /etc/lsb-release >/dev/null 2>&1
+ then
+ ETH_BINARY=eth_byzantium2
+ ETH_HASH="4dc3f208475f622be7c8e53bee720e14cd254c6f"
+ fi
+ wget -q -O /tmp/test/eth https://github.com/ethereum/cpp-ethereum/releases/download/solidityTester/$ETH_BINARY
+ test "$(shasum /tmp/test/eth)" = "$ETH_HASH /tmp/test/eth"
+ sync
+ chmod +x /tmp/test/eth
+ sync # Otherwise we might get a "text file busy" error
+ ETH_PATH="/tmp/test/eth"
fi
- wget -q -O /tmp/test/eth https://github.com/ethereum/cpp-ethereum/releases/download/solidityTester/$ETH_BINARY
- test "$(shasum /tmp/test/eth)" = "$ETH_HASH /tmp/test/eth"
- sync
- chmod +x /tmp/test/eth
- sync # Otherwise we might get a "text file busy" error
- ETH_PATH="/tmp/test/eth"
-fi
-# This trailing ampersand directs the shell to run the command in the background,
-# that is, it is forked and run in a separate sub-shell, as a job,
-# asynchronously. The shell will immediately return the return status of 0 for
-# true and continue as normal, either processing further commands in a script
-# or returning the cursor focus back to the user in a Linux terminal.
-$ETH_PATH --test -d /tmp/test &
-ETH_PID=$!
+}
+
+# $1: data directory
+# echos the PID
+function run_eth()
+{
+ $ETH_PATH --test -d "$1" >/dev/null 2>&1 &
+ echo $!
+ # Wait until the IPC endpoint is available.
+ while [ ! -S "$1"/geth.ipc ] ; do sleep 1; done
+ sleep 2
+}
+
+download_eth
+ETH_PID=$(run_eth /tmp/test)
+
+progress="--show-progress"
+if [ "$CI" ]
+then
+ progress=""
+fi
-# Wait until the IPC endpoint is available. That won't be available instantly.
-# The node needs to get a little way into its startup sequence before the IPC
-# is available and is ready for the unit-tests to start talking to it.
-while [ ! -S /tmp/test/geth.ipc ]; do sleep 2; done
-echo "--> IPC available."
-sleep 2
-# And then run the Solidity unit-tests (once without optimization, once with),
-# pointing to that IPC endpoint.
echo "--> Running tests without optimizer..."
- "$REPO_ROOT"/build/test/soltest --show-progress $testargs_no_opt -- --ipcpath /tmp/test/geth.ipc && \
- echo "--> Running tests WITH optimizer..." && \
- "$REPO_ROOT"/build/test/soltest --show-progress $testargs_opt -- --optimize --ipcpath /tmp/test/geth.ipc
-ERROR_CODE=$?
+"$REPO_ROOT"/build/test/soltest $testargs_no_opt $progress -- --ipcpath /tmp/test/geth.ipc
+echo "--> Running tests WITH optimizer..."
+"$REPO_ROOT"/build/test/soltest $testargs_opt $progress -- --optimize --ipcpath /tmp/test/geth.ipc
+
+wait $CMDLINE_PID
+
pkill "$ETH_PID" || true
sleep 4
-pgrep "$ETH_PID" && pkill -9 "$ETH_PID" || true
-exit $ERROR_CODE
+pgrep "$ETH_PID" && pkill -9 "$ETH_PID" || true \ No newline at end of file